// Autogenerated from Pigeon (v11.0.1), do not edit directly.
// See also: https://pub.dev/packages/pigeon

package org.moxxy.moxxy_native.contacts

import android.util.Log
import io.flutter.plugin.common.BasicMessageChannel
import io.flutter.plugin.common.BinaryMessenger
import io.flutter.plugin.common.MessageCodec
import io.flutter.plugin.common.StandardMessageCodec

private fun wrapResult(result: Any?): List<Any?> {
    return listOf(result)
}

private fun wrapError(exception: Throwable): List<Any?> {
    if (exception is FlutterError) {
        return listOf(
            exception.code,
            exception.message,
            exception.details,
        )
    } else {
        return listOf(
            exception.javaClass.simpleName,
            exception.toString(),
            "Cause: " + exception.cause + ", Stacktrace: " + Log.getStackTraceString(exception),
        )
    }
}

/**
 * Error class for passing custom error details to Flutter via a thrown PlatformException.
 * @property code The error code.
 * @property message The error message.
 * @property details The error details. Must be a datatype supported by the api codec.
 */
class FlutterError(
    val code: String,
    override val message: String? = null,
    val details: Any? = null,
) : Throwable()

/** The type of icon to use when no avatar path is provided. */
enum class FallbackIconType(val raw: Int) {
    NONE(0),
    PERSON(1),
    NOTES(2),
    ;

    companion object {
        fun ofRaw(raw: Int): FallbackIconType? {
            return values().firstOrNull { it.raw == raw }
        }
    }
}

/** Generated interface from Pigeon that represents a handler of messages from Flutter. */
interface MoxxyContactsApi {
    fun recordSentMessage(name: String, jid: String, avatarPath: String?, fallbackIcon: FallbackIconType)

    companion object {
        /** The codec used by MoxxyContactsApi. */
        val codec: MessageCodec<Any?> by lazy {
            StandardMessageCodec()
        }

        /** Sets up an instance of `MoxxyContactsApi` to handle messages through the `binaryMessenger`. */
        @Suppress("UNCHECKED_CAST")
        fun setUp(binaryMessenger: BinaryMessenger, api: MoxxyContactsApi?) {
            run {
                val channel = BasicMessageChannel<Any?>(binaryMessenger, "dev.flutter.pigeon.moxxy_native.MoxxyContactsApi.recordSentMessage", codec)
                if (api != null) {
                    channel.setMessageHandler { message, reply ->
                        val args = message as List<Any?>
                        val nameArg = args[0] as String
                        val jidArg = args[1] as String
                        val avatarPathArg = args[2] as String?
                        val fallbackIconArg = FallbackIconType.ofRaw(args[3] as Int)!!
                        var wrapped: List<Any?>
                        try {
                            api.recordSentMessage(nameArg, jidArg, avatarPathArg, fallbackIconArg)
                            wrapped = listOf<Any?>(null)
                        } catch (exception: Throwable) {
                            wrapped = wrapError(exception)
                        }
                        reply.reply(wrapped)
                    }
                } else {
                    channel.setMessageHandler(null)
                }
            }
        }
    }
}
